clc
clear all
close all

%% Llamamos al script de funciones

funciones

%% Datos
NEF = 5; %nmero de efectos

Datos_operacion

U = linspace(2,2,NEF); %KW/m2*K supuesto coeficiente de transferencia de calor inicial para los evaporadores de acuerdo a la viscosidad (McCabe)
%% Clculos iniciales

%% Clculos previos para corrientes de entrada y salida
L(NEF) = F*xF/xL(NEF); % Lquido de salida del ltimo efecto Kg/s

hF = hzumo(TF,xF);

%% Balances de materia

Vt = F - L(NEF); % Agua total evaporada

nei = [1:1:NEF-1];
V(nei)= Vt/NEF; %Suponemos igual agua evaporada en cada evaporador
for i=1:NEF-1
L(i)=F-sum(V(1:i));
xL(i)=F*xF/L(i);
end

%% Distribucin inicial de temperaturas

caid_total = Ts - TV(NEF); % Cada total de temperatura

%Primera suposicin de los saltos trmicos en cada efecto
caid_T = 5;

for i=NEF:-1:2
    TL(i)=TV(i)+EPB(xL(i));
    TV(i-1)=TL(i)+caid_T;
end

%Suma elevacion del punto de ebullicin para calcular la cada disponible
sum_EPB = 0;
sum_inv_U = 0;
for i=1:NEF
    sum_EPB=sum_EPB+EPB(xL(i));
    sum_inv_U=sum_inv_U+1/(U(i));
end

caid_disp = caid_total - sum_EPB; % Cada disponible restando la elevacin del punto de ebullicin

caid_T = (caid_disp/sum_inv_U)./U; %Vector de saltos trmicos en cada efecto

TL(1) = Ts-caid_T(1);
for i = 1:NEF-1
    TV(i)=TL(i)-EPB(xL(i));
    TL(i+1)= TV(i)-caid_T(i+1);
end

%% Balances de entalpa
% Resolucin del balance de energa del segundo, tercer y cuarto efectos para
% calcular los flujos de vapor reales
V0 = V;
fun =@(V) [(F-V(1))*hzumo(TL(1),xL(1))+V(1)*dif_h(TV(1),xL(1))-(F-V(1)-V(2))*hzumo(TL(2),xL(2))-V(2)*hvapsobre(TV(2),xL(2));...
    (F-V(1)-V(2))*hzumo(TL(2),xL(2))+V(2)*dif_h(TV(2),xL(2))-(F-V(1)-V(2)-V(3))*hzumo(TL(3),xL(3))-V(3)*hvapsobre(TV(3),xL(3));...
    (F-V(1)-V(2)-V(3))*hzumo(TL(3),xL(3))+V(3)*dif_h(TV(3),xL(3))-(F-V(1)-V(2)-V(3)-V(4))*hzumo(TL(4),xL(4))-V(4)*hvapsobre(TV(4),xL(4));...
    (F-V(1)-V(2)-V(3)-V(4))*hzumo(TL(4),xL(4))+V(4)*dif_h(TV(4),xL(4))-L(NEF)*hzumo(TL(NEF),xL(NEF))-(Vt-V(1)-V(2)-V(3)-V(4))*hvapsobre(TV(NEF),xL(NEF))];
V = fsolve(fun,V0);

%% Bucle iterativo

for j=1:100
    
    % clculo del nuevo perfil de temperaturas
        
   for i=NEF-1:-1:1
     TV(i)=TL(i+1)+caid_T(i+1); TL(i)=TV(i)+EPB(xL(i)); 
   end
    
  fun =@(V) [(F-V(1))*hzumo(TL(1),xL(1))+V(1)*dif_h(TV(1),xL(1))-(F-V(1)-V(2))*hzumo(TL(2),xL(2))-V(2)*hvapsobre(TV(2),xL(2));...
    (F-V(1)-V(2))*hzumo(TL(2),xL(2))+V(2)*dif_h(TV(2),xL(2))-(F-V(1)-V(2)-V(3))*hzumo(TL(3),xL(3))-V(3)*hvapsobre(TV(3),xL(3));...
    (F-V(1)-V(2)-V(3))*hzumo(TL(3),xL(3))+V(3)*dif_h(TV(3),xL(3))-(F-V(1)-V(2)-V(3)-V(4))*hzumo(TL(4),xL(4))-V(4)*hvapsobre(TV(4),xL(4));...
    (F-V(1)-V(2)-V(3)-V(4))*hzumo(TL(4),xL(4))+V(4)*dif_h(TV(4),xL(4))-L(NEF)*hzumo(TL(NEF),xL(NEF))-(Vt-V(1)-V(2)-V(3)-V(4))*hvapsobre(TV(NEF),xL(NEF))];
   V = fsolve(fun,V0);

    
    for i=1:NEF
       U(i)= Ufun(xL(i),TL(i)-273); %KW/m2K
    end
    
    Q(1)=(F-V(1))*hzumo(TL(1),xL(1))+V(1)*hvapsobre(TV(1),xL(1))-F*hF;
     for i=2:NEF
    Q(i)=V(i-1)*dif_h(TV(i-1),xL(i-1));
     end
    
    area=Q./(U.*caid_T);
    
    error=abs((area-mean(area))./mean(area));
    if error <=1.e-12 break; end
    
    for i=1:NEF
    caid_T(i)=caid_T(i)*area(i)/mean(area);
    
    end
    
    
    for i=1:NEF-1
        xL(i)=F*xF/(F-sum(V(1:i)));
    end
end

%% rea

A = mean(area);
%% Consumo de vapor vivo

S = Q(1)/hlatente(Ts) %Kg/s

%% Vapor del ltimo efecto

V(NEF) = Vt - sum(V(1:NEF-1)); %Kg/s

%% Flujos lquido
L(1)=F-V(1); 
for i=2:NEF-1
L(i)=L(i-1)-V(i);
end
%% Economa del evaporador

E = Vt/S 

%% Condensador
%Suponemos que el agua de refrigeracin entra a 25 C y sale a 35 C

ma = V(NEF)*dif_h(TV(NEF),xL(NEF))/((Cp_H2O_L(T_ref_sal)*T_ref_sal)-(Cp_H2O_L(T_ref_ent)*T_ref_ent))/dens_H2O; %m3/s flujo de agua de refrigeracin para el condensador

%Clculo del rea de intercambio necesaria para el condensador Q=UA*difT

dif_Tl = ((TL(NEF)-308)-(TV(NEF)-298))/(log((TL(NEF)-308)/(TV(NEF)-298))); %diferencia de temperatura media logartmica, el agua entra a 25C y sale a 35C

Ac = V(NEF)*dif_h(TV(NEF),xL(NEF))/(Uc*dif_Tl); % m2

%% Guardamos los datos de inters
save('5_efec','A','S','E','V','L','TV','dens','F','NEF','ma','Ac')

%% Salida de resultados

fprintf('RESULTADOS\n');
fprintf('----------------------------------------------\n');
fprintf('nmero iteraciones: %d\n',j);
fprintf('Alimento, F= %.1f (kg/h)\nLquido concentrado, L(NEF)= %.1f(kg/h)\nVapor generado o capacidad del sistema= %.1f (kg/h)\n',F*3600,L(NEF)*3600,Vt*3600);
fprintf('Area de cada intercambiador= %.1f (m2) \n',A);
fprintf('Flujo vapor vivo= %.2f (kg/h) \n',S*3600);
fprintf('Economia= %.2f  \n',E);
fprintf('Agua de refrigeracin ma= %.2f (m3/h) \n',ma*3600);
fprintf('----------------------------------------------\n');
fprintf('Datos operativos en cada efecto\n');
for i=1:NEF
fprintf('--------------- EFECTO %d-------------------------------\n',i);
fprintf('L= %.1f\tV== %.1f (kg/h)\n',L(i)*3600,V(i)*3600);
fprintf('xL= %.2f%%\n',xL(i)*100);
fprintf('Q= %.1f (kW)\n',Q(i));
end