clc
clear all
close all

%% Llamamos al script de funciones

funciones

%% Datos
NEF=1;
Datos_operacion

%% Balance de materia
L= F*xF/xL; %Kg/s
V = F-L; %Kg/s

%% Balance de energa
caid_total = Ts-TV;
caid_disp = caid_total - EPB(xL);
TL = Ts - caid_disp;
hF = hzumo(TF,xF);

U = Ufun(xL,TL-273);
Q = (V*hvapsobre(TV,xL)+L*hzumo(TL,xL)-F*hF); %KW
A = Q/(U*caid_disp); %m2

S = Q/hlatente(Ts); % Kg/s
E = V/S; 

%% Condensador
%Suponemos que el agua de refrigeracin entra a 25 C y sale a 35 C

ma = V(NEF)*dif_h(TV(NEF),xL(NEF))/((Cp_H2O_L(T_ref_sal)*T_ref_sal)-(Cp_H2O_L(T_ref_ent)*T_ref_ent))/dens_H2O; %m3/s flujo de agua de refrigeracin para el condensador

%Clculo del rea de intercambio necesaria para el condensador Q=UA*difT

dif_Tl = ((TL(NEF)-308)-(TV(NEF)-298))/(log((TL(NEF)-308)/(TV(NEF)-298))); %diferencia de temperatura media logartmica, el agua entra a 25C y sale a 35C

Ac = V(NEF)*dif_h(TV(NEF),xL(NEF))/(Uc*dif_Tl); % m2

%% Guardamos los datos de inters
save('1_efec','A','S','E','V','L','TV','dens','F','NEF','ma','Ac')

%% Salida de resultados

fprintf('RESULTADOS\n');
fprintf('----------------------------------------------\n');
fprintf('Alimento, F= %.1f (kg/h)\nLquido concentrado, L(NEF)= %.1f(kg/h)\nVapor generado o capacidad del sistema= %.1f (kg/h)\n',F*3600,L(NEF)*3600,V*3600);
fprintf('Area del intercambiador= %.1f (m2) \n',A);
fprintf('Flujo vapor vivo= %.2f (kg/h) \n',S*3600);
fprintf('Economia= %.2f  \n',E);
fprintf('Flujo de lquido= %.2f (kg/h) \n',L*3600);
fprintf('Potencia trmica Q= %.2f (kW) \n',Q);
fprintf('Agua de refrigeracin ma= %.2f (m3/h) \n',ma*3600);